// Craig S. Kaplan

// A quick demonstration of using the JSONObjectCache in conjunction
// with the university's Weather JSON URL.  You can see how a
// cache object is creted, and how the JSONObject is acquired from
// it every frame (but not downloaded from the internet each time).

JSONObjectCache cache;

void setup()
{
  size( 400, 100 );
  cache = new JSONObjectCache(
    "https://api.uwaterloo.ca/v2/weather/current.json" );
}

void draw()
{
  background( 0 );
  fill( 255 );
  JSONObject obj = cache.getJSONObject();
  text( "Current temperature: " +
    obj.getJSONObject( "data" )
       .getFloat( "temperature_current_c" ) + " degrees",
       10, 60 );
}