class JSONObjectCache
{
  JSONObject obj;
  String url;
  
  int last_request_time;
  int timeout_interval;
  
  JSONObjectCache( String url )
  {
    this.obj = null;
    this.url = url;
    this.last_request_time = 0;
    this.timeout_interval = 60;
  }
  
  // Set the number of seconds you want between
  // fresh loads of the JSON Object.  The default
  // is 60 (one minute).  Please don't change this
  // without a very good reason.
  void setTimeoutInterval( int secs )
  {
    timeout_interval = secs;
  }
  
  // Call this method without any arguments, and 
  // it will give you back the JSON object associated
  // with the URL you gave to the constructor when
  // you created this cache.  You can call it as
  // frequently as you want, since most of the time
  // it will just return the previously downloaded JSON
  // object to you without asking the internet for a 
  // new copy.
  JSONObject getJSONObject()
  {
    boolean need_new = false;
    if( obj == null ) {
      need_new = true;
    } else if( (millis() - last_request_time) >= (timeout_interval * 1000) ) {
      need_new = true;
    }
    
    if( need_new ) {
      obj = loadJSONObject( url );
      last_request_time = millis();
      // If you uncomment the line below, you'll be able to
      // track the actual times the system goes out and
      // gets the JSONObject from the internet.
      // println( "Fetching" );
    }
    
    return obj;
  }
}